RailwayCashBox/Controllers/TrainRouteController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Microsoft.AspNet.Identity;
using RailwayCashBox.DAL.Entities;
using RailwayCashBox.DAL.Repositories;
using RailwayCashBox.Models;

namespace RailwayCashBox.Controllers
{
	[Authorize(Roles = "manager, admin")]
	public class TrainRouteController : Controller
    {
        private Repository db = new Repository();

        public ActionResult Index()
        {
            return View(db.GetRoutes());
        }

		[AllowAnonymous]
		public ActionResult Details(int id)
        {
            var trainroute = db.GetTrainRoute(id);
            if (trainroute == null)
            {
                return HttpNotFound();
            }
            return View(trainroute);
        }

	    public ActionResult CreateDetails()
	    {
			return View();
		}

		[HttpPost]
        [ValidateAntiForgeryToken]
		public ActionResult CreateDetails(TrainRouteCreateDetails details)
		{
			if (ModelState.IsValid)
			{
                return RedirectToAction("Create", details);
			}
			return View();
		}

		public ActionResult Create(TrainRouteCreateDetails details)
        {
            ViewBag.Stations = new SelectList(db.GetAllStations(), "Id", "Name");

			var trainRoute = new TrainRoute() {StartDate = DateTime.Today};
			trainRoute.StartStation.DepartureTime = DateTime.Today;
			trainRoute.EndStation.ArrivalTime = DateTime.Today;
			for (int i = 0; i < details.NumberOfIntermediateStations; i++)
				trainRoute.IntermediateStations.Add(new StationStop());

			for (int i = 0; i < details.NumberOfCars; i++)
				trainRoute.TrainCars.Add(new TrainCar());

			return View(trainRoute);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(TrainRoute trainroute)
        {
            ViewBag.Stations = new SelectList(db.GetAllStations(), "Id", "Name");

	        var isvalid = true;
	        if (trainroute.StartStation.DepartureTime == null)
	        {
		        ModelState.AddModelError("", "Начальная станция не имеет времени отправления");
		        isvalid = false;
	        }
	        if (trainroute.EndStation.ArrivalTime == null)
	        {
		        ModelState.AddModelError("", "Конечная станция не имеет времени прибытия");
				isvalid = false;
			}
			if (trainroute.IntermediateStations.Any(s => !s.ArrivalTime.HasValue || !s.DepartureTime.HasValue))
	        {
		        ModelState.AddModelError("", "В промежуточных станциях неправильно проставлены даты");
				isvalid = false;
			}

			if (!isvalid)
				return View(trainroute);

			if (ModelState.IsValid)
			{
				var stations = db.GetAllStations();

				trainroute.StartStation.Station = stations.First(s => s.Id == trainroute.StartStation.StationIdForEditing);
				trainroute.EndStation.Station = stations.First(s => s.Id == trainroute.EndStation.StationIdForEditing);
				foreach (var intermediateStation in trainroute.IntermediateStations)
				{
					intermediateStation.Station = stations.First(s => s.Id == intermediateStation.StationIdForEditing);
				}

				db.CreateTrainRoute(trainroute);
                return RedirectToAction("Index");
            }


			return View(trainroute);
        }
        
        public ActionResult Edit(int id = 0)
        {
	        ViewBag.Stations = db.GetAllStations();
			TrainRoute trainroute = db.GetTrainRoute(id);
            if (trainroute == null)
            {
                return HttpNotFound();
            }
            return View(trainroute);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(TrainRoute trainroute)
        {
            if (ModelState.IsValid)
            {
                db.EditTrainRoute(trainroute);

                return RedirectToAction("Index");
            }
            ViewBag.Stations = new SelectList(db.GetAllStations(), "Id", "Name");

			return View(trainroute);
        }

        // GET: /TrainRoute/Delete/5
        public ActionResult Delete(int id)
        {
            return View(db.GetTrainRoute(id));
        }

        // POST: /TrainRoute/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id, TrainRoute trainRoute)
        {
            db.DeleteTrainRoute(id);
            return RedirectToAction("Index");
        }

	    public ActionResult ShowSchedule(int id)
	    {
		    var model = new TrainSchedule
		    {
			    TrainRouteId = id,
			    Records = db.GetSchedule(id)
                    .Where(r => r.DepartureDate < DateTime.Now.AddMonths(3))
                    .OrderBy(r => r.DepartureDate)
                    .ToList()
		    };

		    return View(model);
	    }

	    public ActionResult ClearScheduleForRoute(int id)
	    {
		    db.ClearScheduleForRoute(id);
		    return RedirectToAction("ShowSchedule", new {id});
	    }

	    public ActionResult DeleteTrainScheduleRecord(int id)
	    {
			var record = db.GetTrainScheduleRecord(id);
		    var routeId = record.TrainRoute.Id;
		    db.DeleteTrainScheduleRecord(id);

		    return RedirectToAction("ShowSchedule", new {id = routeId});
	    }

	    public ActionResult GenerateScheduleDetailsForRoute(int id)
	    {
		    return View(new GenerateScheduleDetails {RouteId = id,FromDate = DateTime.Today, ToDate = DateTime.Today});
	    }

        [HttpPost]
		public ActionResult GenerateScheduleDetailsForRoute(GenerateScheduleDetails generateScheduleDetails)
        {
	        if (ModelState.IsValid)
	        {
		        var route = db.GetTrainRoute(generateScheduleDetails.RouteId);
		        var records = TrainScheduleHelper.CreateTrainScheduleRecords(route, generateScheduleDetails.FromDate,
			        generateScheduleDetails.ToDate);
		        db.SaveSchedule(records);
		        return RedirectToAction("ShowSchedule", new {id = generateScheduleDetails.RouteId});
	        }
	        return View(generateScheduleDetails);
        }

		protected override void Dispose(bool disposing)
		{
			db.Dispose();
			base.Dispose(disposing);
		}
	}

	public static class BookingHelper
	{
		public static BookingState GetBookingState(string currentSeat, List<string> previouslyBooked, List<string> choosen)
		{
			if(previouslyBooked.Contains(currentSeat))
				return BookingState.Booked;
			if (choosen.Contains(currentSeat))
				return BookingState.Chosen;

			return BookingState.Free;
		}
	}

	public enum BookingState
	{
		Free,
		Booked,
		Chosen
	}
}

RailwayCashBox/Views/TrainRoute/Create.cshtml
@using RailwayCashBox
@using RailwayCashBox.DAL.Entities
@model RailwayCashBox.DAL.Entities.TrainRoute

@{
    ViewBag.Title = "Создать новый маршрут";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Создать маршрут</h2>

@using (Html.BeginForm("Create", "TrainRoute", null, FormMethod.Post, new { @class = "form-horizontal", role = "form" })) {
    @Html.AntiForgeryToken()
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })

    <fieldset>
        <legend>Маршрут</legend>

        @Html.HiddenFor(m => m.Id, new { data_val = "false" })
        <div class="form-group">
            @Html.LabelFor(m => m.Code, new { @class = "col-md-3 control-label" })
            <div class="col-md-5">
                @Html.TextBoxFor(m => m.Code, new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.Code)
            </div>
        </div>
        <div class="form-group">
            @Html.LabelFor(m => m.StartDate, new { @class = "col-md-3 control-label" })
            <div class="col-md-5">
                @Html.EditorFor(m => m.StartDate)
                @Html.ValidationMessageFor(model => model.StartDate)
            </div>
        </div>
        @Html.HiddenFor(m => m.StartStation.Id, new { data_val = "false" })
        <div class="form-group">
            @Html.Label("Станция отправления", new {@class = "col-md-3 control-label"})
            <div class="col-md-5">
                @Html.DropDownListFor(m => m.StartStation.StationIdForEditing, ViewBag.Stations as SelectList, new {@class = "form-control"})
                @Html.EditorFor(m => m.StartStation.DepartureTime)
                @Html.ValidationMessageFor(model => model.StartStation.StationIdForEditing)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(m => m.IntermediateStations, new { @class = "col-md-3 control-label" })
        </div>

        @for (int i = 0; i < Model.IntermediateStations.Count; i++)
        {
            @Html.HiddenFor(m => m.IntermediateStations[i].Id, new { data_val = "false" })
            <div class="form-group">
                <div class="col-md-3" style="text-align: right">№@(i+1)</div>
                <div class="col-md-5">
                    @Html.DropDownListFor(m => m.IntermediateStations[i].StationIdForEditing, ViewBag.Stations as SelectList, new { @class = "form-control" })
                    @Html.EditorFor(m => m.IntermediateStations[i].ArrivalTime)
                    @Html.EditorFor(m => m.IntermediateStations[i].DepartureTime)
                </div>
            </div>
        }

        <div class="form-group">
            @Html.Label("Станция прибытия", new { @class = "col-md-3 control-label" })
            <div class="col-md-5">
                @Html.HiddenFor(m => m.EndStation.Id, new { data_val = "false" })
                @Html.DropDownListFor(m => m.EndStation.StationIdForEditing, ViewBag.Stations as SelectList, new {@class = "form-control"})
                @Html.EditorFor(m => m.EndStation.ArrivalTime)
                @Html.ValidationMessageFor(model => model.EndStation.StationIdForEditing)
            </div>
        </div>
      
        <div class="form-group">
            @Html.LabelFor(m => m.StopDate, new { @class = "col-md-3 control-label" })
            <div class="col-md-5">
                @Html.EditorFor(m => m.StopDate)
                @Html.ValidationMessageFor(model => model.StopDate)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(m => m.ScheduleType, new { @class = "col-md-3 control-label" })
            <div class="col-md-5">
                @Html.DropDownListFor(m => Model.ScheduleType, Helper.GetEnumValues(typeof(ScheduleType), Model.ScheduleType, ScheduleTypeToDescription.ToDescription), new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.ScheduleType)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(m => m.TrainCars, new {@class = "col-md-3 control-label"})
        </div>
        @for (int i = 0; i < Model.TrainCars.Count; i++)
        {
            @Html.HiddenFor(m => Model.TrainCars[i].Id, new { data_val = "false" })
            <div class="form-group">
                <div class="col-md-3" style="text-align: right">№@(i+1)</div>
                <div class="col-md-5">
                    <div>
                        @Html.LabelFor(m => Model.TrainCars[i].CarType, new { @class = "control-label" })
                        @Html.DropDownListFor(m => Model.TrainCars[i].CarType, Helper.GetEnumValues(typeof(CarType), Model.TrainCars[i].CarType, CarTypeToDescription.ToDescription),new { @class = "form-control" })
                        @Html.ValidationMessageFor(model => Model.TrainCars[i].CarType)
                    </div> 
                    <div>
                        @Html.LabelFor(m => Model.TrainCars[i].Number, new { @class = "control-label" })
                        @Html.TextBoxFor(m => Model.TrainCars[i].Number, new {@class = "form-control"}) 
                        @Html.ValidationMessageFor(model => Model.TrainCars[i].Number)
                    </div>
                    <div>
                        @Html.LabelFor(m => Model.TrainCars[i].SeatPrice, new { @class = "control-label" })
                        @Html.TextBoxFor(m => Model.TrainCars[i].SeatPrice, new { @class = "form-control" })
                        @Html.ValidationMessageFor(model => Model.TrainCars[i].SeatPrice)
                    </div>     
                </div>
            </div>
        }

        <div class="form-group">
            <div class="col-md-offset-2 col-md-5">
                <input type="submit" value="Создать" class="btn btn-default" />
            </div>
        </div>
    </fieldset>
}

<div>
    @Html.ActionLink("Вернуться", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

RailwayCashBox/Views/TrainRoute/CreateDetails.cshtml
@model RailwayCashBox.Models.TrainRouteCreateDetails

@{
    ViewBag.Title = "Опции создания маршрута";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

@using (Html.BeginForm("CreateDetails", "TrainRoute", null, FormMethod.Post, new { @class = "form-horizontal", role = "form" }))
{
    @Html.AntiForgeryToken()
    @Html.ValidationSummary(true)

    <fieldset>
        <legend>@ViewBag.Title</legend>

        <div class="form-group">
            @Html.LabelFor(m => m.NumberOfIntermediateStations, new {@class = "col-md-4 control-label"})
            <div class="col-md-6">
                @Html.TextBoxFor(m => m.NumberOfIntermediateStations, new {@class = "form-control"})
                @Html.ValidationMessageFor(model => model.NumberOfIntermediateStations)
            </div>
        </div>
        <div class="form-group">
            @Html.LabelFor(m => m.NumberOfCars, new {@class = "col-md-4 control-label"})
            <div class="col-md-6">
                @Html.TextBoxFor(m => m.NumberOfCars, new {@class = "form-control"})
                @Html.ValidationMessageFor(model => model.NumberOfCars)
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-4 col-md-6">
                <input type="submit" value="Создать..." class="btn btn-default"/>
            </div>
        </div>
    </fieldset>
}

<div>
    @Html.ActionLink("Вернуться", "Index")
</div>

RailwayCashBox/Views/TrainRoute/Delete.cshtml
@model RailwayCashBox.DAL.Entities.TrainRoute

@{
    ViewBag.Title = "Удалить";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Удалть маршрут</h2>

<fieldset>
    <legend>Маршрут</legend>

    <div class="display-label">
         @Html.DisplayNameFor(model => model.Code)
    </div>
    <div class="display-field">
        @Html.DisplayFor(model => model.Code)
    </div>

    <div class="display-label">
         @Html.DisplayNameFor(model => model.StartDate)
    </div>
    <div class="display-field">
        @Html.DisplayFor(model => model.StartDate)
    </div>

    <div class="display-label">
         @Html.DisplayNameFor(model => model.StopDate)
    </div>
    <div class="display-field">
        @Html.DisplayFor(model => model.StopDate)
    </div>
</fieldset>
@using (Html.BeginForm()) {
    @Html.AntiForgeryToken()
    <p>
        <input type="submit" value="Удалить" /> |
        @Html.ActionLink("Вернуться", "Index")
    </p>
}

RailwayCashBox/Views/TrainRoute/Details.cshtml
@using RailwayCashBox.DAL.Entities
@model RailwayCashBox.DAL.Entities.TrainRoute

@{
    ViewBag.Title = "Описание";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Описание маршрута:</h2>

<fieldset>
    <div class="display-label">
        @Html.DisplayNameFor(model => model.Code)
    </div>
    <div class="display-field">
        @Html.DisplayFor(model => model.Code)
    </div>
    <br/>
    <h4>Отправление:</h4>
    <div class="display-label">
        @Html.DisplayNameFor(model => model.StartStation.Station.Name)
    </div>
    <div class="display-field">
        <b>@Html.DisplayFor(model => model.StartStation.Station.Name)</b>
    </div>
    <br/>
    <div class="display-label">
        @Html.DisplayNameFor(model => model.StartStation.DepartureTime)
    </div>
    <div class="display-field">
        @Html.DisplayFor(model => model.StartStation.DepartureTime)
    </div>
    <br/>
    <h4>@Html.DisplayNameFor(model => model.IntermediateStations):</h4>
    <div class="display-field">
        @foreach (var item in Model.IntermediateStations)
        {
            var stoptime = item.DepartureTime - item.ArrivalTime;
            <span>Станция <b>'@item.Station.Name'</b>, Время прибытия: '@string.Format("{0:dd-MM-yyyy HH:mm}", item.ArrivalTime)', Время отправления: '@string.Format("{0:dd-MM-yyyy HH:mm}", item.DepartureTime)' </span><br/>
            <span>Время стоянки поезда на данной станции: @stoptime</span><br />
        }
    </div>
    <br/>
    <h4>Прибытие:</h4>
    <div class="display-label">
        @Html.DisplayNameFor(model => model.EndStation.Station.Name)
    </div>
    <div class="display-field">
        <b>@Html.DisplayFor(model => model.EndStation.Station.Name)</b>
    </div>
    <br/>
    <div class="display-label">
        @Html.DisplayNameFor(model => model.EndStation.ArrivalTime)
    </div>
    <div class="display-field">
        @Html.DisplayFor(model => model.EndStation.ArrivalTime)
    </div>
    <br/>
    <div class="display-label">
        @Html.DisplayNameFor(model => model.StopDate)
    </div>
    <div class="display-field">
        @Html.DisplayFor(model => model.StopDate)
    </div>
    <br />
    <div class="display-label">
        @Html.DisplayNameFor(model => model.ScheduleType)
    </div>
    <div class="display-field">
        @ScheduleTypeToDescription.ToDescription(Model.ScheduleType)
    </div>
    <br />

    <h4>@Html.DisplayNameFor(model => model.TrainCars):</h4>
    <div class="display-field">
        @foreach (var item in Model.TrainCars)
        {
            <span>Вагон № @item.Number, Тип вагона: @(CarTypeToDescription.ToDescription(item.CarType)), </span>
            <span>Стоимость билета: @item.SeatPrice грн, </span>
            <span>Кол-во мест: @item.GetNumberOfSeats()</span><br />
        }
</div>
</fieldset>
<br/>

<p>
    @Html.ActionLink("Редактировать", "Edit", new { id=Model.Id }) | 
    @Html.ActionLink("Вернуться", "Index")
</p>

RailwayCashBox/Views/TrainRoute/Edit.cshtml
@using RailwayCashBox
@using RailwayCashBox.DAL.Entities
@model RailwayCashBox.DAL.Entities.TrainRoute

@{
    ViewBag.Title = "Редактирование маршрута";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Редактирование маршрута</h2>

@using (Html.BeginForm("Edit", "TrainRoute", null, FormMethod.Post, new { @class = "form-horizontal", role = "form" }))
{
    @Html.AntiForgeryToken()
    @Html.ValidationSummary(true)

    <fieldset>
        <legend>Маршрут</legend>

        @Html.HiddenFor(m => m.Id, new { data_val = "false" })
        <div class="form-group">
            @Html.LabelFor(m => m.Code, new { @class = "col-md-3 control-label" })
            <div class="col-md-5">
                @Html.TextBoxFor(m => m.Code, new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.Code)
            </div>
        </div>
        <div class="form-group">
            @Html.LabelFor(m => m.StartDate, new { @class = "col-md-3 control-label" })
            <div class="col-md-5">
                @Html.EditorFor(m => m.StartDate)
                @Html.ValidationMessageFor(model => model.StartDate)
            </div>
        </div>
        @Html.HiddenFor(m => m.StartStation.Id, new { data_val = "false" })
        <div class="form-group">
            @Html.Label("Станция отправления", new { @class = "col-md-3 control-label" })
            <div class="col-md-5">
                @Html.DropDownListFor(m => m.StartStation.StationIdForEditing, new SelectList(ViewBag.Stations, "Id", "Name", Model.StartStation.StationIdForEditing) , new { @class = "form-control" })
                @Html.EditorFor(m => m.StartStation.DepartureTime)
                @Html.ValidationMessageFor(model => model.StartStation.StationIdForEditing)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(m => m.IntermediateStations, new { @class = "col-md-3 control-label" })
        </div>

        @for (int i = 0; i < Model.IntermediateStations.Count; i++)
        {
            @Html.HiddenFor(m => m.IntermediateStations[i].Id, new { data_val = "false" })
            <div class="form-group">
                <div class="col-md-3" style="text-align: right">№@(i + 1)</div>
                <div class="col-md-5">
                    @Html.DropDownListFor(m => m.IntermediateStations[i].StationIdForEditing, new SelectList(ViewBag.Stations, "Id", "Name", Model.IntermediateStations[0].StationIdForEditing), new { @class = "form-control" })
                    @Html.EditorFor(m => m.IntermediateStations[i].DepartureTime)
                    @Html.EditorFor(m => m.IntermediateStations[i].ArrivalTime)
                </div>
            </div>
        }

        <div class="form-group">
            @Html.Label("Станция прибытия", new { @class = "col-md-3 control-label" })
            <div class="col-md-5">
                @Html.HiddenFor(m => m.EndStation.Id, new { data_val = "false" })
                @Html.DropDownListFor(m => m.EndStation.StationIdForEditing, new SelectList(ViewBag.Stations, "Id", "Name", Model.EndStation.StationIdForEditing), new { @class = "form-control" })
                @Html.EditorFor(m => m.EndStation.ArrivalTime)
                @Html.ValidationMessageFor(model => model.EndStation.StationIdForEditing)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(m => m.StopDate, new {@class = "col-md-3 control-label"})
            <div class="col-md-5">
                @Html.EditorFor(m => m.StopDate)
                @Html.ValidationMessageFor(model => model.StopDate)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(m => m.ScheduleType, new {@class = "col-md-3 control-label"})
            <div class="col-md-5">
                @Html.DropDownListFor(m => Model.ScheduleType, Helper.GetEnumValues(typeof (ScheduleType), Model.ScheduleType, ScheduleTypeToDescription.ToDescription), new {@class = "form-control"})
                @Html.ValidationMessageFor(model => model.ScheduleType)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(m => m.TrainCars, new { @class = "col-md-3 control-label" })
        </div>
        @for (int i = 0; i < Model.TrainCars.Count; i++)
        {
            @Html.HiddenFor(m => Model.TrainCars[i].Id, new { data_val = "false" })
            <div class="form-group">
                <div class="col-md-3" style="text-align: right">№@(i + 1)</div>
                <div class="col-md-5">
                    <div>
                        @Html.LabelFor(m => Model.TrainCars[i].CarType, new { @class = "control-label" })
                        @Html.DropDownListFor(m => Model.TrainCars[i].CarType, Helper.GetEnumValues(typeof(CarType), Model.TrainCars[i].CarType, CarTypeToDescription.ToDescription), new { @class = "form-control" })
                    </div>
                    <div>
                        @Html.LabelFor(m => Model.TrainCars[i].Number, new { @class = "control-label" })
                        @Html.TextBoxFor(m => Model.TrainCars[i].Number, new { @class = "form-control" })
                    </div>
                    <div>
                        @Html.LabelFor(m => Model.TrainCars[i].SeatPrice, new { @class = "control-label" })
                        @Html.TextBoxFor(m => Model.TrainCars[i].SeatPrice, new { @class = "form-control" })
                    </div>
                </div>
            </div>
        }

        <div class="form-group">
            <div class="col-md-offset-2 col-md-5">
                <input type="submit" value="Сохранить" class="btn btn-default" />
            </div>
        </div>
    </fieldset>
}
<div>
    @Html.ActionLink("Вернуться", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

RailwayCashBox/Views/TrainRoute/GenerateScheduleDetailsForRoute.cshtml
@model RailwayCashBox.Models.GenerateScheduleDetails

@{
    ViewBag.Title = "Создать расписание для периода";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

@using (Html.BeginForm("GenerateScheduleDetailsForRoute", "TrainRoute", null, FormMethod.Post, new { @class = "form-horizontal", role = "form" }))
{
    @Html.AntiForgeryToken()
    @Html.ValidationSummary(true)

    @Html.HiddenFor(m => m.RouteId)

    <fieldset>
        <legend>@ViewBag.Title</legend>

        <div class="form-group">
            @Html.LabelFor(m => m.FromDate, new { @class = "col-md-4 control-label" })
            <div class="col-md-6">
                @Html.EditorFor(m => m.FromDate)
                @Html.ValidationMessageFor(model => model.FromDate)
            </div>
        </div>
        <div class="form-group">
            @Html.LabelFor(m => m.ToDate, new { @class = "col-md-4 control-label" })
            <div class="col-md-6">
                @Html.EditorFor(m => m.ToDate)
                @Html.ValidationMessageFor(model => model.ToDate)
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-4 col-md-6">
                <input type="submit" value="Создать..." class="btn btn-default" />
            </div>
        </div>
    </fieldset>
}

<div>
    @Html.ActionLink("Вернуться", "ShowSchedule", new { id = Model.RouteId })
</div>

RailwayCashBox/Views/TrainRoute/Index.cshtml
@model IEnumerable<RailwayCashBox.DAL.Entities.TrainRoute>

@{
    ViewBag.Title = "Маршруты";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Маршруты</h2>

<p>
    @Html.ActionLink("Добавить новый маршрут", "CreateDetails")
</p>
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.Code)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.StartDate)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.StartStation)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.EndStation)
        </th>
        <th></th>
    </tr>

@foreach (var item in Model) {
    <tr>
        <td>
            @Html.DisplayFor(modelItem => item.Code)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.StartDate)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.StartStation.Station.Name)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.EndStation.Station.Name)
        </td>
        <td>
            @Html.ActionLink("Редактировать", "Edit", new { id=item.Id }) |
            @Html.ActionLink("Детали", "Details", new { id=item.Id }) |
            @Html.ActionLink("Удалить", "Delete", new { id = item.Id }) |
            @Html.ActionLink("Показать расписание", "ShowSchedule", new {id = item.Id}) 
            
        </td>
    </tr>
}

</table>

RailwayCashBox/Views/TrainRoute/ShowSchedule.cshtml
@model RailwayCashBox.Models.TrainSchedule

@{
    ViewBag.Title = "Маршруты";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Расписание</h2>

<p>
    @Html.ActionLink("Очистить", "ClearScheduleForRoute", new { id = Model.TrainRouteId }) |
    @Html.ActionLink("Создать расписание", "GenerateScheduleDetailsForRoute", new {id = Model.TrainRouteId})
</p>
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.Records[0].TrainRoute)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Records[0].DepartureDate)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Records[0].ArrivalDate)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Records[0].SeatBookings)
        </th>
        <th>
            Куплено
        </th>
        <th></th>
    </tr>

    @foreach (var item in Model.Records)
    {
        <tr>
            <td>
                @Html.ActionLink(item.TrainRoute.Code, "Details", new { id = item.TrainRoute.Id })
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.DepartureDate)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.ArrivalDate)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.SeatBookings.Count)
            </td>
            <td>
                @item.SeatBookings.Count(r => r.Booked)
            </td>
            <td>
                @Html.ActionLink("Удалить", "DeleteTrainScheduleRecord", new {id = item.Id})
            </td>
        </tr>
    }

</table>

<div>
    @Html.ActionLink("Вернуться", "Index")
</div>